

from flask import *
#from client import Client
import time
import json
import os
import csv
import sqlite3
import hashlib
    
app = Flask(__name__)  

DB = 'inventory.db'

def getmd5(data):
    s = ''
    for i in data:
        s += str(i).strip()
    r = hashlib.md5(s.encode(encoding='UTF-8')).hexdigest()
    return r
    
def formatted_time():
    return time.strftime("%Y/%m/%d", time.localtime())

def dbsetup(data):
    """
    '{
    "25":{"location": 28, "tag": "7.61/8.10", "amount": 3 },
    "26":{"location": 29, "tag": "7.59/8.10", "amount": 3 }
    }'
    """
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    c.execute("DROP TABLE IF EXISTS inventory")
    conn.commit()
    c.execute('''CREATE TABLE IF NOT EXISTS inventory
        (ID                   INTEGER PRIMARY KEY AUTOINCREMENT,
        SORT                  INT,
        LOCATION              INT,
        TAG                   TEXT,
        AMOUNT                INT,
        NAME                  TEXT,
        DATE                  TEXT);''')
    conn.commit()
    for e in data.keys():
        v = (int(e), data[e]["location"], data[e]["tag"], data[e]["amount"])
        c.execute('''INSERT INTO inventory
            (SORT,LOCATION,TAG,AMOUNT) \
            VALUES {v}'''.format(v=v))

    conn.commit()
    conn.close()

def dbinsert(tb='inventory', v=()):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    #c.execute('''INSERT INTO {tb}
    #        (ID,NU,MOULD,SPEC,AMOUNT,OUTDATE,RECEIVRE,MANAGER,\
    #        FAC,SERIAL,STATE,INDATE,COLLECTOR,COMMET,MD5) \
    #        VALUES {v}'''.format(tb=tb, v=v))
    c.execute("INSERT INTO {tb} VALUES {v};".format(tb=tb, v=v))
    #(2, 'Allen', 25, 'Texas', 15000.00 )
    conn.commit()
    conn.close()
    
def dbselect(tb='inventory'):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    # c.execute("SELECT ID,NU,MOULD,SPEC,AMOUNT,OUTDATE,RECEIVRE,\
    # MANAGER,FAC,SERIAL,STATE,INDATE,COLLECTOR,COMMET,MD5 from {tb};".format(tb=tb))
    c.execute("SELECT * FROM {tb};".format(tb=tb))
    return c.fetchall()

def dbupdate(tb='inventory', d={'ID':123123,'MD5':'asdasdasdasd'}):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    for e in d:
        if isinstance(d[e], str):
            c.execute("UPDATE {tb} SET {h} = '{r}' WHERE ID={id};".format(tb=tb, h=e, r=d[e], id=d['ID']))
        else:
            c.execute("UPDATE {tb} SET {h} = {r} WHERE ID={id};".format(tb=tb, h=e, r=d[e], id=d['ID']))
    conn.commit()
    conn.close()
    
def dbdelete(tb='inventory', i=123123):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    try:
        c.execute("DELETE FROM {tb} WHERE ID={i};".format(tb=tb, i=i))
        LOG('已删除该条目……')
    except:
        LOG('没有该条目……')
    conn.commit()
    conn.close()
    LOG('已删除……')

def dbsearchhead(tb='inventory', h='NU', s='3'):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    #c.execute("SELECT ID,NU,MOULD,SPEC,AMOUNT,OUTDATE,RECEIVRE,MANAGER,\
    #FAC,SERIAL,STATE,INDATE,COLLECTOR,COMMET,MD5 from {tb};".format(tb=tb))
    c.execute("SELECT * FROM {tb} WHERE {h} GLOB '*{s}*';".format(tb=tb, h=h, s=s))
    return c.fetchall()
    
def dbsearchtime(tb='inventory', t=(111111,222222)):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    c.execute("SELECT * FROM {tb} WHERE ID >= {a} AND ID >= {b} ;".format(tb=tb, a=t[0], b=t[1]))
    return c.fetchall()

def dbadd(tb='inventory', d={'ID':123123,'MD5':'asdasdasdasd'}):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    v = (d['ID'],' ',' ',' ',1,'','','','','','','','','','',0,'')
    try:
        c.execute("INSERT INTO {tb} VALUES {v};".format(tb=tb, v=v))
    except:
        pass
    conn.commit()
    conn.close()
    #(2, 'Allen', 25, 'Texas', 15000.00 )
    dbupdate(tb=tb, d=d)

def dbnothave(tb='inventory', md5='md5'):
    conn = sqlite3.connect(DB)
    c = conn.cursor()
    c.execute("SELECT * FROM {tb} WHERE MD5 = '{md5}';".format(tb=tb, md5=md5))
    if c.fetchall() == []:
        return True
    else:
        return False

@app.route('/inventory', methods=['POST','GET'])

# from flask import Flask, request, jsonify
def inventory():
    if request.method == 'POST':
        # 接收JSON数据
        data = request.get_json() # '{"sort": 25, "location": 28, "tag": "7.61/8.10", "name": "Bob"}'
        print("Received data:", data)
        # 处理数据（示例：简单地返回接收到的数据）
        return jsonify({"message": "JSON data received", "yourData": data})
    else:
        # 发送JSON数据
        response_data = {
            "name": "Alice",
            "age": 25,
            "city": "Los Angeles"
        }
        return jsonify(response_data)
        
@app.route('/inventory/init', methods=['POST','GET'])
def inventory_init():
    if request.method == 'POST':
        # 接收JSON数据
        data = request.get_json()  # '{25:{"location": 28, "tag": "7.61/8.10", "amount": 3 }, 26:{"location": 29, "tag": "7.59/8.10", "amount": 3 }}'
        try:
            dbsetup(data)
            return "请求成功", 200
        except:
            return "无法理解", 400
    else:
        # 发送JSON数据
        response_data = {
            "name": "Alice",
            "age": 25,
            "city": "Los Angeles"
        }
        return jsonify(response_data)